<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRecord(); openModal(modal, 'Desglose de Platillos')" class="btn btn-primary">
    <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="dataGrid.data.length === 0 || loading">
    <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="main-card mb-3 card">
    <div class="card-body">

        <div class="animated fadeIn" style="height: 75vh;" *ngIf="!loading">
            <kendo-grid
                    [data]="dataGrid.data"
                    [filter]="filter"
                    [filterable]="false"
                    (filterChange)="filterChange($event)"
                    [selectable]="true"
                    [navigable]="true"
                    [reorderable]="true"
                    [resizable]="true"
                    [sort]="sort"
                    [sortable]="true"
                    (sortChange)="sortChange($event)"
                    [groupable]="true"
                    [group]="groups"
                    (groupChange)="groupChange($event)"
                    (edit)="editRow($event); openModal(modal, 'Desglose de Platillos')"
                    (remove)="deleteRow($event)"
                    (detailExpand)="detailExpand($event)"
                    style="height: 75vh">
                <ng-template kendoGridToolbarTemplate>
                  <button type="button" kendoGridExcelCommand icon="file-excel"
                   [disabled]="dataGrid.data.length === 0"
                   class="btn-success">Exportar Excel</button>
                </ng-template>
                <kendo-grid-column field="dplat" title="Desglose" width="220">
                </kendo-grid-column>
                <kendo-grid-column field="ddesc" title="Descripción">
                </kendo-grid-column>
                <kendo-grid-column field="duso" title="Uso" width="120">
                    <ng-template kendoGridFilterCellTemplate>
                        <kendo-switch
                                (valueChange)="switchChange($event)"
                                offLabel="No"
                                [checked]="checked"
                                onLabel="Si">
                        </kendo-switch>
                    </ng-template>
                    <ng-template kendoGridCellTemplate let-dataItem>
                        <input type="checkbox" [checked]="dataItem.duso" disabled/>
                    </ng-template>
                </kendo-grid-column>
                <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
                    <ng-template kendoGridFilterCellTemplate>
                        <kendo-switch
                                (valueChange)="switchChange($event)"
                                offLabel="No"
                                [checked]="checked"
                                onLabel="Si">
                        </kendo-switch>
                    </ng-template>
                    <ng-template kendoGridCellTemplate let-dataItem>
                        <input type="checkbox" [checked]="dataItem.Inactivo" disabled/>
                    </ng-template>
                </kendo-grid-column>
                <kendo-grid-command-column title="Actions" width="190">
                    <ng-template kendoGridCellTemplate let-isNew="isNew">
                        <button kendoGridEditCommand [primary]="true">Editar</button>
                        <button kendoGridRemoveCommand>Eliminar</button>
                    </ng-template>
                </kendo-grid-command-column>
                <ng-template kendoGridDetailTemplate let-dataItem>
                    <ng-container *ngIf="dataExpand">
                        <app-detalle-desglose-platillos [data]="dataExpand"></app-detalle-desglose-platillos>
                    </ng-container>
                </ng-template>
                <kendo-grid-excel fileName="{{this.heading}}.xlsx" [fetchData]="allData"></kendo-grid-excel>
            </kendo-grid>

        </div>
      <app-loading *ngIf="loading"></app-loading>

    </div>
</div>

<ng-template #modal let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title" id="modal-graf">{{ modalTitle }}</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="row" *ngIf="flagShowForm">
      <form [formGroup]="myFormGroup" class="k-form">
              <legend *ngIf="!flagEdit">Nuevo Desglose</legend>
              <legend *ngIf="flagEdit">Actualizar Desglose</legend>
              <label class="k-form-field">
                  <span>Desglose</span>
                  <input class="k-textbox" name="dplat" maxlength="10"
                         [(ngModel)]="myFormGroup.value.dplat" formControlName="dplat"
                         [readOnly]="flagEdit" autofocus/>
              </label>
              <label class="k-form-field">
                  <span>Descripción</span>
                  <input class="k-textbox" name="ddesc" maxlength="40"
                         [(ngModel)]="myFormGroup.value.ddesc" formControlName="ddesc">
              </label>
              <div class="row">
                  <label class="k-form-field col-4">
                      <span>Uso</span>
                      <kendo-switch
                              class=""
                              name="duso"
                              [(ngModel)]="myFormGroup.value.duso"
                              formControlName="duso"
                              [onLabel]="'Si'"
                              [offLabel]="'No'"
                              readonly="true">
                      </kendo-switch>
                  </label>
                  <label class="k-form-field col-4">
                      <span>Inactivo</span>
                      <kendo-switch
                              class=""
                              name="Inactivo"
                              [(ngModel)]="myFormGroup.value.Inactivo"
                              formControlName="Inactivo"
                              [onLabel]="'Si'"
                              [offLabel]="'No'">
                      </kendo-switch>
                  </label>
              </div>
      </form>
    </div>
  </div>
  <div class="modal-footer">
      <button class="btn btn-success" (click)="guardarForm(); c();"
      [disabled]="myFormGroup.status === 'INVALID'">
        <i class="fas fa-save mr-2"></i>Guardar
      </button>
      <button class="btn btn-secondary" (click)="closeForm(); c('Close click')">Cerrar</button>
  </div>
</ng-template>

